"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.GraphQLCodeBlock = void 0;

var _parser = require("graphql/language/parser");

var _printer = require("graphql/language/printer");

var _react = _interopRequireDefault(require("react"));

var _runParser = require("./runParser");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var GraphQLCodeBlock = function GraphQLCodeBlock(_ref) {
  var className = _ref.className,
      src = _ref.src;
  var formatted;

  try {
    formatted = (0, _printer.print)((0, _parser.parse)(src));
  } catch (e) {
    // eslint-disable-next-line no-console
    console.error(e);
    return /*#__PURE__*/_react["default"].createElement("pre", {
      className: "".concat(className !== null && className !== void 0 ? className : '', " GraphQLCodeBlock error")
    }, src);
  }

  var highlighted = [];
  var rowKeys = [];
  (0, _runParser.runParser)(formatted, function (stream, state, style, rowIndex, newRow) {
    var _sourceText = stream._sourceText,
        _start = stream._start,
        _pos = stream._pos;

    if (newRow) {
      rowKeys.push(_sourceText);
      highlighted.push([]);
    }

    var substr = _sourceText.substring(_start, _pos);

    highlighted[highlighted.length - 1].push( /*#__PURE__*/_react["default"].createElement("span", {
      key: "".concat(rowKeys.length, "-").concat(_start, "-").concat(_pos),
      className: style
    }, substr));
  });
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: "".concat(className !== null && className !== void 0 ? className : '', " GraphQLCodeBlock")
  }, highlighted.map(function (row, index) {
    return /*#__PURE__*/_react["default"].createElement("pre", {
      key: "query-row-".concat(index)
    }, row);
  }));
};

exports.GraphQLCodeBlock = GraphQLCodeBlock;