"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.runParser = void 0;

var _graphqlLanguageServiceParser = require("graphql-language-service-parser");

var runParser = function runParser(src, callback) {
  var parser = (0, _graphqlLanguageServiceParser.onlineParser)();
  var state = parser.startState();
  var lines = src.split('\n');
  lines.forEach(function (line, i) {
    var stream = new _graphqlLanguageServiceParser.CharacterStream(line);
    var newRow = true;

    while (!stream.eol()) {
      var _style = parser.token(stream, state);

      callback(stream, state, _style, i, newRow);
      newRow = false;
    }
  });
};

exports.runParser = runParser;